<template>
  <div class="container">
    <h1 class='ko-b'>Atila Vue</h1>
    <h2>한글폰트</h2>
    <span class="example">
    <i class="bi-alarm"></i> {{name}} {{ last_name () }} {{ msg }}</span>
    <div>{{ video_link }}</div>
    <ul>
      <div v-for='code, index in codelist' :key='code.code'>
        <li v-if='!code.hidden' :class='{"text-muted": !code.enabled}'>{{ code.code }}: {{ code.name }}</li>
      </div>
    </ul>
    <button @click="signUp ()">Sign Up</button>
    <button @click="signIn ()">Sign In</button>
    <button @click="signOut ()">Sign Out</button>
    <button @click="getToken ()">Get FCM Token</button>
    <div><router-link :to="{ name: 'sub'}">Sub Page</router-link></div>
    <div><router-link :to="{ name: 'items'}">Items</router-link></div>
    <div><sub-component></sub-component></div>
  </div>
</template>

<style scoped>
  .example {
    color: v-bind('color');
  }
</style>

<script setup>
import subComponent from '/routes/spa/components/subComponent.vue'

const video_link = backend.media ('영화.avi')
const props = defineProps ({posts: String})
const { state } = useStore ()
const msg = ref ('world!')
const color = ref ('blue!')
const name = computed (() => {return 'Hans'})
const codelist = ref ([])

watch(() => props.visible, (newValue, oldValue) => {
  console.log('props.visible 의 변이가 감지되었을 때 ', {newValue, oldValue})
})


onBeforeMount (async () => {
  // const r = await axios.get (backend.endpoint ('APIS_PREDICTIONS_CODELIST'))
  // codelist.value = r.data.codes
  codelist.value = [{code: '100', name: 'Item 100'}, {code: '100', name: 'Item 200'}]
})
function last_name () {
  return "Roh"
}


let messaging = null
let auth = null

onMounted (async () => {
  frontend.log ("onMounted", "debug")
  messaging = await firebase.getMessaging ()
  firebase.messaging.onMessage (messaging, (msg) => {
    alert (`${msg.data.title}\n\n${msg.data.body}`)
  })

  auth = await firebase.getAuth ()
  firebase.auth.onAuthStateChanged (auth, (user) => {
    if (user) {
      msg.value = `Welcome ${user.email}`
    } else {
      msg.value = `Good bye`
    }
  })
})


async function signUp () {
  let userCredential = null
  try {
    userCredential = await firebase.auth.createUserWithEmailAndPassword (auth, 'hansroh@example.com', 'password')
  } catch (error) {
    frontend.traceback (error)
  }
}

async function signOut () {
  try {
    await firebase.auth.signOut (auth)
  } catch (error) {
    frontend.traceback (error)
  }
  console.log ('sign Out Success')
}

async function signIn () {
  let userCredential = null
  try {
    userCredential = await firebase.auth.signInWithEmailAndPassword (auth, 'hansroh@example.com', 'password')
  } catch (error) {
    frontend.traceback (error)
  }
  let response = null
  response = await backend.post ('ATILA_VUE_AUTH_SIGNIN_WITH_FIREBASE_ID_TOKEN', {id_token: userCredential.user.accessToken})
}


async function getToken () {
  let currentToken = state.$ls.get ('FCM_TOKEN')
  if (!currentToken) {
    frontend.log ('request new FCM token')
    currentToken = await firebase.messaging.getToken (messaging)
    state.$ls.set ("FCM_TOKEN", currentToken)
  }
  frontend.log (`token: ${currentToken}`)
  console.log (currentToken)
  backend.post ("ATILA_VUE_AUTH_SEND_FCM_MESSAGE", {
    token: currentToken,
    title: "FCM Title", body: "This is FCM Message", link: "/spa"
  })
}
</script>
